## open5gs 2.7.6.4782.b7cd.202510192026

=== debian/changelog ===
open5gs (2.7.6.4782.b7cd.202510192026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Sun, 19 Oct 2025 20:28:00 +0000

## open5gs 2.7.6.4782.b7cd.202510202026

=== debian/changelog ===
open5gs (2.7.6.4782.b7cd.202510202026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Mon, 20 Oct 2025 20:27:59 +0000

## open5gs 2.7.6.4782.b7cd.202510212026

=== debian/changelog ===
open5gs (2.7.6.4782.b7cd.202510212026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Tue, 21 Oct 2025 20:28:00 +0000

## open5gs 2.7.6.4783.f3f0.202510222026

=== subprojects/libtins/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.1)
PROJECT(libtins)

OPTION(LIBTINS_BUILD_EXAMPLES "Build examples" ON)
OPTION(LIBTINS_BUILD_TESTS "Build tests" ON)

# Compile in release mode by default
IF(NOT CMAKE_BUILD_TYPE)
    MESSAGE(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
    SET(CMAKE_BUILD_TYPE RelWithDebInfo)
ELSE(NOT CMAKE_BUILD_TYPE)
    MESSAGE(STATUS "Using specified '${CMAKE_BUILD_TYPE}' build type.")
ENDIF(NOT CMAKE_BUILD_TYPE)

# Compilation flags.
IF(MSVC)
    # Don't always use Wall, since VC's /Wall is ridiculously verbose.
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3")
    # Disable VC secure checks, since these are not really issues.
    ADD_DEFINITIONS("-D_CRT_SECURE_NO_WARNINGS=1")
    ADD_DEFINITIONS("-D_SCL_SECURE_NO_WARNINGS=1")
    ADD_DEFINITIONS("-DNOGDI=1")
ELSE()
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
ENDIF()

IF(APPLE)
    # This is set to ON as of policy CMP0042
    SET(CMAKE_MACOSX_RPATH ON)
ENDIF()

# Build output checks
OPTION(LIBTINS_BUILD_SHARED "Build libtins as a shared library." ON)
IF(LIBTINS_BUILD_SHARED)
    MESSAGE(
        STATUS
        "Build will generate a shared library. "
        "Use LIBTINS_BUILD_SHARED=0 to perform a static build"
    )
    SET(LIBTINS_TYPE SHARED)
ELSE(LIBTINS_BUILD_SHARED)
    MESSAGE(STATUS "Build will generate a static library.")
    SET(LIBTINS_TYPE STATIC)
    ADD_DEFINITIONS("-DTINS_STATIC=1")
ENDIF(LIBTINS_BUILD_SHARED)

# The version number.
SET(TINS_VERSION_MAJOR 4)
SET(TINS_VERSION_MINOR 5)
SET(TINS_VERSION_PATCH 0)
SET(LIBTINS_VERSION "${TINS_VERSION_MAJOR}.${TINS_VERSION_MINOR}")

# Required Packages
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# Allow disabling packet capture mechanism
OPTION(LIBTINS_ENABLE_PCAP "Enable capturing packets via libpcap" ON)

# Look for libpcap
IF(LIBTINS_ENABLE_PCAP)
    FIND_PACKAGE(PCAP REQUIRED)
    SET(TINS_HAVE_PCAP ON)
ENDIF()

# Set some Windows specific flags
IF(WIN32)
    # We need to link against these libs
    SET(LIBTINS_OS_LIBS Ws2_32.lib Iphlpapi.lib)

    # Add the NOMINMAX macro to avoid Windows' min and max macros.
    ADD_DEFINITIONS(-DNOMINMAX)

    # MinWG need some extra definitions to compile properly (WIN32 for PCAP and WIN32_WINNT version for ws2tcpip.h)
    IF(MINGW)
        ADD_DEFINITIONS(-DWIN32)
        MACRO(get_WIN32_WINNT version)
        IF (WIN32 AND CMAKE_SYSTEM_VERSION)
            SET(ver ${CMAKE_SYSTEM_VERSION})
            STRING(REPLACE "." "" ver ${ver})
            STRING(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})
            SET(${version} "0x${ver}")
        ENDIF()
        ENDMACRO()
        get_WIN32_WINNT(ver)
        ADD_DEFINITIONS(-D_WIN32_WINNT=${ver})
    ENDIF(MINGW)

ENDIF(WIN32)

INCLUDE(ExternalProject)

# *******************
# Compilation options
# *******************

# Always check for C++ features
INCLUDE(CheckCXXFeatures)

IF(HAS_GCC_BUILTIN_SWAP)
    SET(TINS_HAVE_GCC_BUILTIN_SWAP ON)
ENDIF()

# C++11 support
OPTION(LIBTINS_ENABLE_CXX11 "Compile libtins with c++11 features" ON)
IF(LIBTINS_ENABLE_CXX11)
    # We only use declval and decltype on gcc/clang as VC fails to build that code,
    # at least on VC2013
    IF(HAS_CXX11_RVALUE_REFERENCES AND HAS_CXX11_FUNCTIONAL AND HAS_CXX11_CHRONO AND
       HAS_CXX11_NOEXCEPT AND ((HAS_CXX11_DECLVAL AND HAS_CXX11_DECLTYPE) OR MSVC))
        SET(TINS_HAVE_CXX11 ON)
        MESSAGE(STATUS "Enabling C++11 features")
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_COMPILER_FLAGS}")
    ELSE()
        MESSAGE(WARNING "The compiler doesn't support the necessary C++11 features. "
                        "Disabling C++11 on this build")
    ENDIF()
ELSE(LIBTINS_ENABLE_CXX11)
    MESSAGE(
        WARNING
        "Disabling C++11 features. Use LIBTINS_ENABLE_CXX11=1 to enable them. "
        "Unless you are using an old compiler, you should enable this option, "
        "as it increases the library's performance")
ENDIF(LIBTINS_ENABLE_CXX11)

# IEEE 802.11 and WPA2 decryption support
OPTION(LIBTINS_ENABLE_DOT11 "Compile libtins with IEEE 802.11 support" ON)
OPTION(LIBTINS_ENABLE_WPA2 "Compile libtins with WPA2 decryption features (requires OpenSSL)" ON)
IF(LIBTINS_ENABLE_DOT11)
    SET(TINS_HAVE_DOT11 ON)
    MESSAGE(STATUS "Enabling IEEE 802.11 support.")
    IF(LIBTINS_ENABLE_WPA2)
        FIND_PACKAGE(OpenSSL)
        IF(OPENSSL_FOUND)
            SET(TINS_HAVE_WPA2_DECRYPTION ON)
            MESSAGE(STATUS "Enabling WPA2 decryption support.")
        ELSE()
            MESSAGE(WARNING "Disabling WPA2 decryption support since OpenSSL was not found")
            # Default this to empty strings
            SET(OPENSSL_INCLUDE_DIR "")
            SET(OPENSSL_LIBRARIES "")
        ENDIF()
    ELSE(LIBTINS_ENABLE_WPA2)
        MESSAGE(STATUS "Disabling WPA2 decryption support.")
    ENDIF(LIBTINS_ENABLE_WPA2)
ENDIF(LIBTINS_ENABLE_DOT11)

# Optionally enable TCPIP classes (on by default)
OPTION(LIBTINS_ENABLE_TCPIP "Enable TCPIP classes" ON)
IF(LIBTINS_ENABLE_TCPIP AND TINS_HAVE_CXX11)
    SET(TINS_HAVE_TCPIP ON)
    MESSAGE(STATUS "Enabling TCPIP classes")
ELSE()
    SET(TINS_HAVE_TCPIP OFF)
    MESSAGE(STATUS "Disabling TCPIP classes")
ENDIF()

# Search for libboost
FIND_PACKAGE(Boost)

# Optionally enable the ACK tracker (on by default)
OPTION(LIBTINS_ENABLE_ACK_TRACKER "Enable TCP ACK tracking support" ON)
IF(LIBTINS_ENABLE_ACK_TRACKER AND TINS_HAVE_CXX11)
    IF (Boost_FOUND)
        MESSAGE(STATUS "Enabling TCP ACK tracking support.")
        INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
        SET(TINS_HAVE_ACK_TRACKER ON)
    ELSE()
        MESSAGE(WARNING "Disabling ACK tracking support as boost.icl was not found")
        SET(TINS_HAVE_ACK_TRACKER OFF)
    ENDIF()
ELSE()
    SET(TINS_HAVE_ACK_TRACKER OFF)
    MESSAGE(STATUS "Disabling ACK tracking support")
ENDIF()

# Optionally enable the TCP stream custom data (on by default)
OPTION(LIBTINS_ENABLE_TCP_STREAM_CUSTOM_DATA "Enable TCP stream custom data support" ON)
IF(LIBTINS_ENABLE_TCP_STREAM_CUSTOM_DATA AND TINS_HAVE_CXX11)
    IF (Boost_FOUND)
        MESSAGE(STATUS "Enabling TCP stream custom data support.")
        INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
        SET(TINS_HAVE_TCP_STREAM_CUSTOM_DATA ON)
    ELSE()
        MESSAGE(WARNING "Disabling TCP stream custom data support as boost.any was not found")
        SET(TINS_HAVE_TCP_STREAM_CUSTOM_DATA OFF)
    ENDIF()
ELSE()
    SET(TINS_HAVE_TCP_STREAM_CUSTOM_DATA OFF)
    MESSAGE(STATUS "Disabling TCP stream custom data support")
ENDIF()

OPTION(LIBTINS_ENABLE_WPA2_CALLBACKS "Enable WPA2 callback interface" ON)
IF(LIBTINS_ENABLE_WPA2_CALLBACKS AND TINS_HAVE_WPA2_DECRYPTION AND TINS_HAVE_CXX11)
    SET(STATUS "Enabling WPA2 callback interface")
    SET(TINS_HAVE_WPA2_CALLBACKS ON)
ENDIF()

# Use pcap_sendpacket to send l2 packets rather than raw sockets
IF(WIN32)
    SET(USE_PCAP_SENDPACKET_DEFAULT ON)
ELSE(WIN32)
    SET(USE_PCAP_SENDPACKET_DEFAULT OFF)
ENDIF(WIN32)

OPTION(LIBTINS_USE_PCAP_SENDPACKET "Use pcap_sendpacket to send l2 packets"
        ${USE_PCAP_SENDPACKET_DEFAULT})
IF(LIBTINS_ENABLE_PCAP AND LIBTINS_USE_PCAP_SENDPACKET)
    SET(TINS_HAVE_PACKET_SENDER_PCAP_SENDPACKET ON)
    MESSAGE(STATUS "Using pcap_sendpacket to send l2 packets.")
ENDIF()

# Add a target to generate API documentation using Doxygen
FIND_PACKAGE(Doxygen QUIET)
IF(DOXYGEN_FOUND)
    CONFIGURE_FILE(
        ${CMAKE_CURRENT_SOURCE_DIR}/docs/Doxyfile.in
        ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        @ONLY
    )
    ADD_CUSTOM_TARGET(
        docs
        ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating API documentation with Doxygen" VERBATIM
    )
ENDIF(DOXYGEN_FOUND)

# Configuration file
CONFIGURE_FILE(
  "${PROJECT_SOURCE_DIR}/include/tins/config.h.in"
  "${PROJECT_SOURCE_DIR}/include/tins/config.h"
)

IF (NOT CMAKE_INSTALL_LIBDIR)
    SET(CMAKE_INSTALL_LIBDIR lib)
ENDIF()
IF (NOT CMAKE_INSTALL_BINDIR)
    SET(CMAKE_INSTALL_BINDIR bin)
ENDIF()
# The library output directory
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
# Support for pkg-config
SET(pkgconfig_prefix      ${CMAKE_INSTALL_PREFIX})
SET(pkgconfig_exec_prefix ${CMAKE_INSTALL_PREFIX})
SET(pkgconfig_libdir      ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
SET(pkgconfig_version     ${LIBTINS_VERSION})
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libtins.pc.in
                ${CMAKE_CURRENT_BINARY_DIR}/libtins.pc @ONLY)

INSTALL(
    FILES
    ${CMAKE_CURRENT_BINARY_DIR}/libtins.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

# Confiugure the uninstall script
CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY
)

# Add uninstall target
ADD_CUSTOM_TARGET(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

# ******************
# Add subdirectories
# ******************
ADD_SUBDIRECTORY(src)

IF(LIBTINS_BUILD_EXAMPLES)
    IF(LIBTINS_ENABLE_PCAP)
        ADD_SUBDIRECTORY(examples)
    ELSE()
        MESSAGE(STATUS "Not building examples as pcap support is disabled")
    ENDIF()
ENDIF()

IF(LIBTINS_BUILD_TESTS)
    # Only include googletest if the git submodule has been fetched
    IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/googletest/CMakeLists.txt")
        # Enable tests and add the test directory
        MESSAGE(STATUS "Tests have been enabled")
        SET(GOOGLETEST_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/googletest)
        SET(GOOGLETEST_INCLUDE ${GOOGLETEST_ROOT}/googletest/include)
        SET(GOOGLETEST_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/googletest)
        SET(GOOGLETEST_LIBRARY ${GOOGLETEST_BINARY_DIR}/googletest)

        ExternalProject_Add(
            googletest
            DOWNLOAD_COMMAND ""
            SOURCE_DIR ${GOOGLETEST_ROOT}
            BINARY_DIR ${GOOGLETEST_BINARY_DIR}
            CMAKE_CACHE_ARGS "-DBUILD_GTEST:bool=ON" "-DBUILD_GMOCK:bool=OFF"
                            "-Dgtest_force_shared_crt:bool=ON"
                            "-DCMAKE_CXX_COMPILER:path=${CMAKE_CXX_COMPILER}"
            INSTALL_COMMAND ""
        )
        # Make sure we build googletest before anything else
        ADD_DEPENDENCIES(tins googletest)
        ENABLE_TESTING()
        ADD_SUBDIRECTORY(tests)
    ELSE()
        FIND_PACKAGE(GTest QUIET)
        IF(${GTest_FOUND})
            ENABLE_TESTING()
            ADD_SUBDIRECTORY(tests)
        ELSE()
            MESSAGE(STATUS "googletest git submodule is absent. Run `git submodule init && git submodule update` to get it")
        ENDIF()
    ENDIF()
ENDIF()

# **********************************
# CMake project configuration export
# **********************************

if(UNIX)
    set(CONF_CMAKE_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/libtins")
else()
    set(CONF_CMAKE_INSTALL_DIR CMake)
endif()

# Add all targets to the build-tree export set
EXPORT(
    TARGETS tins
    FILE "${PROJECT_BINARY_DIR}/libtinsTargets.cmake"
)

# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
EXPORT(PACKAGE libtins)

# Create the libtinsConfig.cmake and libtinsConfigVersion.cmake files
# for the build tree
SET(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include")
CONFIGURE_FILE(
    cmake/libtinsConfig.cmake.in
    "${PROJECT_BINARY_DIR}/libtinsConfig.cmake" @ONLY
)
CONFIGURE_FILE(
    cmake/libtinsConfigVersion.cmake.in
    "${PROJECT_BINARY_DIR}/libtinsConfigVersion.cmake" @ONLY
)
# Install the libtinsConfig.cmake and libtinsConfigVersion.cmake
INSTALL(
    FILES
    "${PROJECT_BINARY_DIR}/libtinsConfig.cmake"
    "${PROJECT_BINARY_DIR}/libtinsConfigVersion.cmake"
    DESTINATION ${CONF_CMAKE_INSTALL_DIR}
    COMPONENT dev
)

=== debian/changelog ===
open5gs (2.7.6.4783.f3f0.202510222026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Wed, 22 Oct 2025 20:28:01 +0000

## open5gs 2.7.6.4784.8f2d.202510232026

=== debian/changelog ===
open5gs (2.7.6.4784.8f2d.202510232026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Thu, 23 Oct 2025 20:28:01 +0000

## open5gs 2.7.6.4784.8f2d.202510242026

=== debian/changelog ===
open5gs (2.7.6.4784.8f2d.202510242026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Fri, 24 Oct 2025 20:28:01 +0000

## open5gs 2.7.6.4786.ef14.202510252026

=== debian/changelog ===
open5gs (2.7.6.4786.ef14.202510252026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Sat, 25 Oct 2025 20:28:00 +0000

## open5gs 2.7.6.4787.47d0.202510262026

=== debian/changelog ===
open5gs (2.7.6.4787.47d0.202510262026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Sun, 26 Oct 2025 20:28:01 +0000

## open5gs 2.7.6.4792.9c40.202510272026

=== debian/changelog ===
open5gs (2.7.6.4792.9c40.202510272026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Mon, 27 Oct 2025 20:28:00 +0000

## open5gs 2.7.6.4793.4a6a.202510282026

=== debian/changelog ===
open5gs (2.7.6.4793.4a6a.202510282026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Tue, 28 Oct 2025 20:28:00 +0000

## open5gs 2.7.6.4793.4a6a.202510291800

=== subprojects/libtins/examples/CMakeLists.txt ===
FIND_PACKAGE(Threads QUIET)
FIND_PACKAGE(Boost COMPONENTS regex)

SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/examples)
INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_SOURCE_DIR}/../include
    ${PCAP_INCLUDE_DIR}
)
LINK_LIBRARIES(tins)

IF(TINS_HAVE_CXX11)
    SET(LIBTINS_CXX11_EXAMPLES
        arpmonitor
        dns_queries
        dns_spoof
        dns_stats
        stream_dump
        icmp_responses
        interfaces_info
        tcp_connection_close
        traceroute
        wps_detect
    )
    IF(Boost_REGEX_FOUND)
        SET(LIBTINS_CXX11_EXAMPLES ${LIBTINS_CXX11_EXAMPLES} http_requests)
    ELSE()
        MESSAGE(WARNING "Disabling HTTP requests example since boost.regex was not found")
    ENDIF()
ELSE(TINS_HAVE_CXX11)
    MESSAGE(WARNING "Disabling some examples since C++11 support is disabled.")
ENDIF(TINS_HAVE_CXX11)

ADD_CUSTOM_TARGET(
    examples DEPENDS
    arpspoofing
    ${LIBTINS_CXX11_EXAMPLES}
    beacon_display
    portscan
    route_table
    defragmenter
)

# Make sure we first build libtins
ADD_DEPENDENCIES(examples tins)

ADD_EXECUTABLE(arpspoofing EXCLUDE_FROM_ALL arpspoofing.cpp)
ADD_EXECUTABLE(route_table EXCLUDE_FROM_ALL route_table.cpp)
ADD_EXECUTABLE(defragmenter EXCLUDE_FROM_ALL defragmenter.cpp)
IF(TINS_HAVE_CXX11)
    ADD_EXECUTABLE(arpmonitor EXCLUDE_FROM_ALL arpmonitor.cpp)
    ADD_EXECUTABLE(dns_queries EXCLUDE_FROM_ALL dns_queries.cpp)
    ADD_EXECUTABLE(dns_spoof EXCLUDE_FROM_ALL dns_spoof.cpp)
    ADD_EXECUTABLE(stream_dump EXCLUDE_FROM_ALL stream_dump.cpp)
    ADD_EXECUTABLE(icmp_responses EXCLUDE_FROM_ALL icmp_responses.cpp)
    ADD_EXECUTABLE(interfaces_info EXCLUDE_FROM_ALL interfaces_info.cpp)
    ADD_EXECUTABLE(tcp_connection_close EXCLUDE_FROM_ALL tcp_connection_close.cpp)
    ADD_EXECUTABLE(wps_detect EXCLUDE_FROM_ALL wps_detect.cpp)
    IF (Boost_REGEX_FOUND)
        ADD_EXECUTABLE(http_requests EXCLUDE_FROM_ALL http_requests.cpp)
        TARGET_LINK_LIBRARIES(http_requests ${Boost_LIBRARIES})
    ENDIF()
ENDIF(TINS_HAVE_CXX11)

ADD_EXECUTABLE(beacon_display EXCLUDE_FROM_ALL beacon_display.cpp)

if(THREADS_FOUND)
    IF(TINS_HAVE_CXX11)
        ADD_EXECUTABLE(traceroute EXCLUDE_FROM_ALL traceroute.cpp)
        ADD_EXECUTABLE(dns_stats EXCLUDE_FROM_ALL dns_stats.cpp)
        TARGET_LINK_LIBRARIES(traceroute ${CMAKE_THREAD_LIBS_INIT})
        TARGET_LINK_LIBRARIES(dns_stats ${CMAKE_THREAD_LIBS_INIT})
    ENDIF(TINS_HAVE_CXX11)
    IF(WIN32)
        MESSAGE(WARNING "Disabling portscan example since it doesn't compile on Windows.")
    ELSE()
        ADD_EXECUTABLE(portscan EXCLUDE_FROM_ALL portscan.cpp)
        TARGET_LINK_LIBRARIES(portscan ${CMAKE_THREAD_LIBS_INIT})
    ENDIF()
ELSE()
    MESSAGE(WARNING "Disabling portscan and traceroute examples since pthreads library was not found.")
ENDIF()

=== debian/changelog ===
open5gs (2.7.6.4793.4a6a.202510291800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Wed, 29 Oct 2025 18:02:04 +0000

=== subprojects/freeDiameter/contrib/debian/control ===
Source: freediameter
Section: contrib/net
Priority: extra
Maintainer: Sebastien Decugis <sdecugis@freediameter.net>
Build-Depends: debhelper ( >= 7.3.9),
 cmake, make, gcc, g++, bison, flex,
 libsctp-dev, libgnutls-dev | gnutls-dev, libidn11-dev,
 libpq-dev, libmysqlclient-dev, libxml2-dev, swig, python-dev,
 libgcrypt11-dev | libgcrypt20-dev
Standards-Version: 3.8.3
Homepage: http://www.freediameter.net

Package: freediameter-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The freeDiameter libraries.
 This package contains the freeDiameter framework core libraries, 
 required by all freeDiameter components.
 It may also be useful for other projects which need to 
 perform operations on Diameter messages. 
 .
 The freeDiameter framework provides support for the Diameter
 Base Protocol. Without any extension, the framework can only
 be used as a Diameter routing agent. You probably want to 
 install some freeDiameter extension(s) to extend its 
 features, and also the freediameter-daemon package that
 will initialize the framework for you.
 .
 See 'freeDiameter-dev' package to retrieve the API for the library.

Package: freediameter-dev
Architecture: any
Section: contrib/devel
Depends: freediameter-common (= ${binary:Version}), libsctp-dev, libgnutls-dev, libgcrypt-dev
Description: This package provides the development files for freeDiameter.

Package: freediameter-daemon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, freediameter-common (= ${binary:Version})
Suggests: ssl-cert, freediameter-dictionary-rfc4005, freediameter-dictionary-rfc4072, freediameter-dictionary-rfc4740,
  freediameter-dictionary-mip6, freediameter-dictionary-legacy
Description: The freeDiameter daemon. 
 This daemon is a simple loader for the freeDiameter framework.
 It is shipped with a small set of extensions, for
 example to configure the routing behavior. See the 
 examples in /usr/share/freediameter* for more details.

Package: freediameter-debug-tools
Architecture: any
Section: contrib/debug
Depends: ${misc:Depends}, freediameter-common (= ${binary:Version})
Suggests: python, libmysqlclient16 | libmysqlclient18
Description: freeDiameter debug tools.
 This package provides useful tools to help tracking 
 problems in freeDiameter installation. For example,
 the dbg_interactive.fdx extension allows access to the 
 framework via a python interpreter console.  

Package: freediameter-dictionary-rfc4005
Architecture: any
Depends: ${misc:Depends}, freediameter-common (= ${binary:Version})
Description: RFC4005 (NASREQ) dictionary support.
 This freeDiameter extension provides the dictionary support
 for commands and AVP defined in RFC4005 (NASREQ).
 .
 In order to use this extension, your main freeDiameter 
 configuration file must contain a LoadExtension directive. 
 See freeDiameter documentation for more details. 
 .
 This extension does not require a configuration file.

Package: freediameter-dictionary-rfc4006
Architecture: any
Depends: ${misc:Depends}, freediameter-common (= ${binary:Version})
Description: RFC4006 (DCCA) dictionary support (incomplete).
 This freeDiameter extension provides the dictionary support
 for commands and AVP defined in RFC4006 (DCCA).
 .
 In order to use this extension, your main freeDiameter 
 configuration file must contain a LoadExtension directive. 
 See freeDiameter documentation for more details. 
 .
 This extension does not require a configuration file.
 .
 Currently this extension is not complete: only AVP definitions 
 are included. See the source file for more details.

Package: freediameter-dictionary-rfc4072
Architecture: any
Depends: ${misc:Depends}, freediameter-common (= ${binary:Version}), freediameter-dictionary-rfc4005 (= ${binary:Version})
Description: RFC4072 (Diameter EAP) dictionary support.
 This freeDiameter extension provides the dictionary support
 for commands and AVP defined in RFC4072 (Diameter EAP).
 .
 In order to use this extension, your main freeDiameter 
 configuration file must contain a LoadExtension directive. 
 See freeDiameter documentation for more details. 
 .
 This extension does not require a configuration file.

Package: freediameter-dictionary-rfc4740
Architecture: any
Depends: ${misc:Depends}, freediameter-common (= ${binary:Version})
Description: RFC4740 (Diameter SIP) dictionary support.
 This freeDiameter extension provides the dictionary support
 for commands and AVP defined in RFC4740 (Diameter SIP).
 .
 In order to use this extension, your main freeDiameter 
 configuration file must contain a LoadExtension directive. 
 See freeDiameter documentation for more details. 
 .
 This extension does not require a configuration file.

Package: freediameter-dictionary-mip6
Architecture: any
Depends: ${misc:Depends}, freediameter-common (= ${binary:Version})
Description: Diameter Mobile IPv6 application dictionary support.
 This package contains a set of extensions to provide the support
 for commands and AVP defined in several RFCs related to
 Diameter MIPv6. It is split is several extensions:
 mip6a, mip6i, nas-mipv6, rfc5777.
 .
 In order to use these extensions, your main freeDiameter 
 configuration file must contain LoadExtension directives. 
 See freeDiameter documentation for more details. 
 .
 These extensions do not require a configuration file.

Package: freediameter-dictionary-legacy
Architecture: any
Depends: ${misc:Depends}, freediameter-common (= ${binary:Version}), libxml2
Description: Legacy XML dictionary files support.
 This freeDiameter extension allows the use of XML dictionary
 files with the freeDiameter framework. Please note that
 dictionaries provided as XML files come with less features
 than native binary format, so the later should be preferred
 when possible.
 .
 In order to use this extension, your main freeDiameter 
 configuration file must contain a LoadExtension directive. 
 See freeDiameter documentation for more details. 
 .
 This extension requires a configuration file. See 
 dict_legacy_xml.conf.sample for documentation.

Package: freediameter-radius-gateway
Architecture: any
Depends: ${misc:Depends}, freediameter-daemon (= ${binary:Version})
Suggests: freediameter-dictionary-rfc4072 (= ${binary:Version}), freediameter-dictionary-rfc4740 (= ${binary:Version})
Description: RADIUS/Diameter extensible gateway.
 This freeDiameter extension implements a RADIUS to Diameter
 gateway. It allows a RADIUS client to connect to a Diameter
 server.
 .
 The support for specific Diameter applications and/or RADIUS 
 extensions is provided in the gateway by the use of plugins.
 Currently, the following plugins are available:
  - echodrop.rgwx : drop or echo a RADIUS attribute. 
                    The attribute is not converted to Diameter.
		    See echodrop.rgwx.conf.sample for details.
  - auth.rgwx : Convert Access-Request to Diameter AAR or DER.
                Requests For Comments: RADIUS: 2865, 3162, 2868,
		2869, 3579; Diameter: 4005, 4072.
		Requires freediameter-dictionary-rfc4072.
  - sip.rgwx  : Convert Access-Request to Diameter SIP messages.
                Requests For Comments: Diameter: 4740.
		Requires freediameter-dictionary-rfc4740.
  - acct.rgwx : Converts Accounting-Request (2866) to Diameter 
                ACR (3588).
		Requires freediameter-dictionary-rfc4072.
 .
 In order to use this extension, your main freeDiameter 
 configuration file must contain a LoadExtension directive. 
 See freeDiameter documentation for more details. 
 .
 This extension requires a configuration file.
 See app_radgw.conf.sample for more details.

Package: freediameter-accounting-server
Architecture: any
Depends: ${misc:Depends}, freediameter-daemon (= ${binary:Version}), libpq5
Suggests: freediameter-dictionary-rfc4072
Description: freeDiameter simple Accounting server.
 This freeDiameter extension implements the Diameter Base 
 Accounting application. It saves the accounting records
 in a PostgreSQL database backend in a highly configurable
 maneer.
 .
 In order to use this extension, your main freeDiameter 
 configuration file must contain a LoadExtension directive. 
 See freeDiameter documentation for more details. 
 .
 This extension requires a configuration file.
 See app_acct.conf.sample for more details.
 .
 You may find some useful resources to parse the saved records
 in the contrib/app_acct_tools folder in source package.

Package: freediameter-eap-server
Architecture: any
Depends: ${misc:Depends}, freediameter-daemon (= ${binary:Version}), libmysqlclient16 | libmysqlclient18, freediameter-dictionary-rfc4072 (= ${binary:Version})
Description: freeDiameter Diameter EAP server implementation.
 This freeDiameter extension implements a Diameter EAP server. 
 It supports EAP-MD5 and EAP-TLS methods currently.
 .
 In order to use this extension, your main freeDiameter 
 configuration file must contain a LoadExtension directive. 
 See freeDiameter documentation for more details. 
 .
 This extension requires a configuration file.
 See app_diameap.conf.sample and 
 http://diameap.yagami.freediameter.net for more details.

Package: freediameter-sip-server
Architecture: any
Depends: ${misc:Depends}, freediameter-daemon (= ${binary:Version}), libmysqlclient16 | libmysqlclient18, freediameter-dictionary-rfc4740 (= ${binary:Version})
Description: freeDiameter Diameter SIP server implementation.
 This freeDiameter extension implements a prototype 
 Diameter SIP server.
 See http://www.freediameter.net/trac/wiki/app_sip.fdx for
 status information.
 .
 In order to use this extension, your main freeDiameter 
 configuration file must contain a LoadExtension directive. 
 See freeDiameter documentation for more details. 
 .
 This extension requires a configuration file.
 See app_sip.conf.sample for more details.

## open5gs 2.7.6.4793.4a6a.202510301800

=== debian/changelog ===
open5gs (2.7.6.4793.4a6a.202510301800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Thu, 30 Oct 2025 18:02:02 +0000

## open5gs 2.7.6.4796.49ee.202510311800

=== debian/changelog ===
open5gs (2.7.6.4796.49ee.202510311800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Fri, 31 Oct 2025 18:02:02 +0000

=== subprojects/freeDiameter/contrib/debian/changelog ===
freediameter (UNRELEASED) UNRELEASED; urgency=low

  *

freediameter (1.5.0) RELEASED; urgency=low

  * freeDiameter:
    - Add -g to help
    - Change -d and -q to control syslog level, as per stdout logging.
    - Syslog to LOG_DAEMON.
    - Actually syslog to LOG_DEBUG, now that -d/-q are used.
    - Add -p pidfile
    - SCTP client: bind to local endpoints configured with ListenOn so
      that the SCTP INIT only contains those local endpoint addresses,
      matching what is advertised in the CER.
  * Base dictionary: Add rules for Experimental-Result.
  * All extensions: Hide symbols except for fd_ext_init(), fd_ext_fini(),
    and fd_ext_depends.
  * dbg_dict_dump.fdx: add extension to write the dictionary
    to the given file or to the log.
  * dbg_dict_dump_json.fdx: add extension to write the dictionary as JSON
    to the given file or stdout.
  * dict_dcca_3gpp.fdx: Update to 3GPP Release 15, adding many standards.
    This adds 96 TYPEs, 145 ENUMVALs, 791 AVPs, 52 RULEs.
    There are various breaking changes (documented below).
  * contrib/dictionary_dcca_3gpp.json: Remove non-3GPP AVPs that are
    actually from base IETF RFCs:
      - MIP6-Feature-Vector (124). IETF RFC 5447
      - Service-Selection (493). IETF RFC 5778
      - Mobile-Node-Identifier (506). IETF RFC 5779
      - QoS-Capability (578). IETF RFC 5777.
  * New API: fd_msg_add_result(): set Result-Code or Experimental-Result.
  * New API: log level FD_LOG_INFO.
  * fd_conf_dump(): fix formatting of local endpoints.
  * fd_msg_search_avp(): support searching avp as well as msg.
  * Fix compiler warnings.
  * Add ERRORS_ON_WARNINGS cmake boolean to enable fatal compiler warnings.
  * New tool: grep_fd_dict_dump: cleanup fd_dict_dump() output in logs.
  * New tool: csv_to_fd: convert .csv with AVP tables to freeDiameter C or JSON.
  * New tool: org_to_csv: convert .org files into .csv files.

  * dict_dcca_3gpp.fdx changes per update to 3GPP Release 15 as at 2019-12:
    - AVP changes:
      - 3GPP-CG-IPv6-Address (14) renamed to 3GPP-CG-Ipv6-Address (14).
      - 3GPP-GGSN-IPv6-Address (16) renamed to 3GPP-GGSN-Ipv6-Address (16).
      - 3GPP-IPv6-DNS-Servers (17) renamed to 3GPP-Ipv6-DNS-Servers (17).
      - 3GPP-SGSN-IPv6-Address (15) renamed to 3GPP-SGSN-Ipv6-Address (15).
      - 3GPP2-BSID (9010) flag M MUST.
      - 3GPP2-BSID (9010) type changed from OctetString to UTF8String.
      - ADC-Revalidation-Time (2801) Time removed in 3GPP TS 29.212 V12.1.0 (2013-06).
      - ADC-Rule-Base-Name (1095) flag M MUST.
      - ADC-Rule-Definition (1094) flag M MUST.
      - ADC-Rule-Install (1092) flag M MUST.
      - ADC-Rule-Name (1096) flag M MUST.
      - ADC-Rule-Remove (1093) flag M MUST.
      - ADC-Rule-Report (1097) flag M MUST.
      - Application-Service-Type (2102) type changed from UTF8String to Enumerated.
      - Application-Session-Id (2103) type changed from UTF8String to Unsigned32.
      - Call-Barring-Infor-List (1488) renamed to Call-Barring-Info (1488).
      - External-Identifier (28) OctetString replaced by External-Identifier (3111) UTF8String.
      - LCS-Requestor-Id (1239) renamed to LCS-Requestor-ID (1239).
      - LCS-Requestor-Id-String (1240) renamed to LCS-Requestor-ID-String (1240).
      - MBMS-BMSC-SSM-IPv6-Address (919) renamed to MBMS-BMSC-SSM-Ipv6-Address (919).
      - MBMS-GGSN-IPv6-Address (917) renamed to MBMS-GGSN-Ipv6-Address (917).
      - MBMSGW-Address (2307) renamed to MBMS-GW-Address (2307).
      - Measurement-Period-LTE (1656) code changed to Measurement-Period-LTE (1655).
      - Measurement-Period-UMTS (1655) code changed to Measurement-Period-UMTS (1656).
      - MME-LocationInformation (1600) renamed to MME-Location-Information(1600).
      - PDG-Address (895) Address removed in 3GPP TS 32.299 V12.6.0 (2014-09).
      - PDG-Charging-Id (896) Unsigned32 removed in 3GPP TS 32.299 V12.6.0 (2014-09).
      - PDN-Connection-ID (1065) flag M MUST NOT.
      - PoC-User-Role-info-Units (1254) renamed to PoC-User-Role-Info-Units (1254).
      - PS-to-CS-Session-Continuity (1099) flag M MUST NOT.
      - SS-Status (1477) type changed from Grouped to OctetString.
      - Status (2702) renamed to Status-AS-Code (2702).
      - WAG-Address (890) Address removed in 3GPP TS 32.299 V12.6.0 (2014-09).
      - WAG-PLMN-Id (891) OctetString removed in 3GPP TS 32.299 V12.6.0 (2014-09).
      - WLAN-Information (875) Grouped removed in 3GPP TS 32.299 V12.6.0 (2014-09).
      - WLAN-Radio-Container (892) Grouped removed in 3GPP TS 32.299 V12.6.0 (2014-09).
      - WLAN-Session-Id (1246) UTF8String removed in 3GPP TS 32.299 V12.6.0 (2014-09).
      - WLAN-Technology (893) Unsigned32 removed in 3GPP TS 32.299 V12.6.0 (2014-09).
      - WLAN-UE-Local-IPAddress (894) Address removed in 3GPP TS 32.299 V12.6.0 (2014-09).
    - AVP renames:
      - Rename Call-Barring-Infor-List (1488) to Call-Barring-Info (1488).
      - Rename LCS-Requestor-Id (1239) to LCS-Requestor-ID (1239).
      - Rename LCS-Requestor-Id-String (1240) to LCS-Requestor-ID-String (1240).
      - Rename MBMSGW-Address (2307) to MBMS-GW-Address (2307).
      - Rename MME-LocationInformation (1600) to MME-Location-Information(1600).
      - Rename PoC-User-Role-info-Units (1254) to PoC-User-Role-Info-Units (1254).
      - Rename Status (2702) to Status-AS-Code (2702).
    - AVP name conflicts:
      - Time-Window (3818) in 3GPP TS 29.345 V12.1.0 (2014-12) predates
        Time-Window-29.154 (4204) in 3GPP TS 29.154 V13.1.0 (2016-03).
    - Add Enumerated(3GPP/Experimental-Result-Code). 145 values.
    - Update standards:
      - 3GPP TS 29.061 V15.5.0 (2018-12). 15 AVPs.
      - 3GPP TS 29.173 V15.0.0 (2018-06). 1 AVP.
      - 3GPP TS 29.212 V15.9.0 (2019-12). 46 AVPs.
      - 3GPP TS 29.214 V15.7.0 (2019-09). 27 AVPs.
      - 3GPP TS 29.229 V15.2.0 (2019-09). 8 AVPs.
      - 3GPP TS 29.272 V15.10.0 (2019-12). 44 AVPs.
      - 3GPP TS 29.329 V15.2.0 (2019-09). 5 AVPs.


## open5gs 2.7.6.4797.7d83.202511011800

=== debian/changelog ===
open5gs (2.7.6.4797.7d83.202511011800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Sat, 01 Nov 2025 18:02:00 +0000

## open5gs 2.7.6.4799.6a1d.202511021800

=== debian/changelog ===
open5gs (2.7.6.4799.6a1d.202511021800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Sun, 02 Nov 2025 18:02:04 +0000

## open5gs 2.7.6.4799.6a1d.202511031800

=== debian/changelog ===
open5gs (2.7.6.4799.6a1d.202511031800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Mon, 03 Nov 2025 18:02:07 +0000

## open5gs 2.7.6.4801.348d.202511041800

=== debian/changelog ===
open5gs (2.7.6.4801.348d.202511041800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Tue, 04 Nov 2025 18:02:10 +0000

## open5gs 2.7.6.4801.348d.202511051800

=== debian/changelog ===
open5gs (2.7.6.4801.348d.202511051800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Wed, 05 Nov 2025 18:02:06 +0000

## open5gs 2.7.6.4802.4642.202511061800

=== debian/changelog ===
open5gs (2.7.6.4802.4642.202511061800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Thu, 06 Nov 2025 18:02:13 +0000

## open5gs 2.7.6.4802.4642.202511071800

=== subprojects/usrsctp/CMakeLists.txt ===
#
# Copyright (C) 2015-2015 Oleg Alexeenkov
# Copyright (C) 2015-2019 Felix Weinrank
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the project nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#

project(usrsctplib C)
cmake_minimum_required(VERSION 3.0)

# Debug build type as default
if (NOT CMAKE_BUILD_TYPE)
	message(STATUS "No build type selected, using DEBUG")
	set(CMAKE_BUILD_TYPE "DEBUG")
endif ()

include(CheckStructHasMember)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckCCompilerFlag)

#################################################
# CHECK OPTIONS
#################################################

option(sctp_invariants "Add runtime checks" 0)
if (sctp_invariants)
	add_definitions(-DINVARIANTS)
endif ()

option(sctp_debug "Provide debug information" 1)
if (sctp_debug)
	add_definitions(-DSCTP_DEBUG)
endif ()

option(sctp_inet "Support IPv4" 1)
if (sctp_inet)
	add_definitions(-DINET)
endif ()

option(sctp_inet6 "Support IPv6" 1)
if (sctp_inet6)
	add_definitions(-DINET6)
endif ()

option(sctp_werror "Treat warning as error" 1)

option(sctp_build_shared_lib "Build USRSCTP as shared library" 0)

option(sctp_build_programs "Build example programs" 1)

option(sctp_sanitizer_address "Compile with address sanitizer" 0)

option(sctp_sanitizer_memory "Compile with memory sanitizer" 0)

option(sctp_build_fuzzer "Compile in clang fuzzing mode" 0)

if (sctp_sanitizer_address AND sctp_sanitizer_memory)
	message(FATAL_ERROR "Can not compile with both sanitizer options")
endif ()


#################################################
# CHECK FOR TYPES AND FUNCTIONS
#################################################

check_include_files("sys/queue.h" have_sys_queue_h)
if (have_sys_queue_h)
	add_definitions(-DHAVE_SYS_QUEUE_H)
endif ()

check_include_files("sys/socket.h;linux/if_addr.h" have_linux_if_addr_h)
if (have_linux_if_addr_h)
	add_definitions(-DHAVE_LINUX_IF_ADDR_H)
endif ()

check_include_files("sys/socket.h;linux/rtnetlink.h" have_linux_rtnetlink_h)
if (have_linux_rtnetlink_h)
	add_definitions(-DHAVE_LINUX_RTNETLINK_H)
endif ()

check_include_files("sys/types.h;netinet/in.h;netinet/ip.h;netinet/ip_icmp.h" have_netinet_ip_icmp_h)
if (have_netinet_ip_icmp_h)
	add_definitions(-DHAVE_NETINET_IP_ICMP_H)
endif ()

check_include_files("stdatomic.h" have_stdatomic_h)
if (have_stdatomic_h)
	add_definitions(-DHAVE_STDATOMIC_H)
endif ()


#################################################
# CHECK STRUCT MEMBERS
#################################################

set(CMAKE_REQUIRED_INCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/usrsctplib")

check_include_file(usrsctp.h have_usrsctp_h)
if (NOT have_usrsctp_h)
	message(FATAL_ERROR "usrsctp.h not found")
endif ()

check_struct_has_member("struct sockaddr" "sa_len" "sys/types.h;sys/socket.h" have_sa_len)
if (have_sa_len)
	message(STATUS "have_sa_len")
	add_definitions(-DHAVE_SA_LEN)
endif ()

check_struct_has_member("struct sockaddr_in" "sin_len" "sys/types.h;netinet/in.h" have_sin_len)
if (have_sin_len)
	message(STATUS "have_sin_len")
	add_definitions(-DHAVE_SIN_LEN)
endif ()

check_struct_has_member("struct sockaddr_in6" "sin6_len" "sys/types.h;netinet/in.h" have_sin6_len)
if (have_sin6_len)
	message(STATUS "have_sin6_len")
	add_definitions(-DHAVE_SIN6_LEN)
endif ()

check_struct_has_member("struct sockaddr_conn" "sconn_len" "usrsctp.h" have_sconn_len)
if (have_sconn_len)
	message(STATUS "HAVE_SCONN_LEN")
	add_definitions(-DHAVE_SCONN_LEN)
endif ()


#################################################
# COMPILER SETTINGS
#################################################

# Determine if compiler is Visual Studio compiler or Clang in MSVC compatible mode
if (CMAKE_C_COMPILER_ID MATCHES "MSVC" OR CMAKE_C_SIMULATE_ID MATCHES "MSVC")
  set(C_COMPILER_IS_MSVC_LIKE TRUE)
endif()

# SETTINGS FOR VISUAL STUDIO COMPILER
if (C_COMPILER_IS_MSVC_LIKE)
	if (CMAKE_C_FLAGS MATCHES "/W[0-4]")
		string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
	else ()
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /W4")
	endif ()

	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4100") # 'identifier' : unreferenced formal parameter
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4127") # conditional expression is constant
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4200") # nonstandard extension used : zero-sized array in struct/union
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4214") # bit field types other than int
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4706") # assignment within conditional expression
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4245") # 'conversion' : conversion from 'type1' to 'type2', signed/unsigned mismatch
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4389") # 'operator' : signed/unsigned mismatch
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4702") # unreachable code
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4701") # Potentially uninitialized local variable 'name' used

	# ToDo
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4244") # 'conversion' conversion from 'type1' to 'type2', possible loss of data

	if (sctp_werror)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /WX")

		if (CMAKE_C_COMPILER_ID MATCHES "Clang")
			# temporary disable exta clang warnings preventing compilation
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /clang:-Wno-unused-function")
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /clang:-Wno-missing-field-initializers")
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /clang:-Wno-sign-compare")
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /clang:-Wno-format")
		endif()
	endif ()
# SETTINGS FOR UNIX COMPILER
elseif (CMAKE_C_COMPILER_ID MATCHES "Clang" OR CMAKE_C_COMPILER_ID MATCHES "AppleClang" OR CMAKE_C_COMPILER_ID MATCHES "GNU")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -pedantic -Wall -Wextra")

	check_c_compiler_flag(-Wfloat-equal has_wfloat_equal)
	if (has_wfloat_equal)
		set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -Wfloat-equal")
	endif ()

	check_c_compiler_flag(-Wshadow has_wshadow)
	if (has_wshadow)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")
	endif ()

	check_c_compiler_flag(-Wpointer-arith has_wpointer_aritih)
	if (has_wpointer_aritih)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpointer-arith")
	endif ()

	check_c_compiler_flag(-Wunreachable-code has_wunreachable_code)
	if (has_wunreachable_code)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunreachable-code")
	endif ()

	check_c_compiler_flag(-Winit-self has_winit_self)
	if (has_winit_self)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Winit-self")
	endif ()

	check_c_compiler_flag(-Wno-unused-function has_wno_unused_function)
	if (has_wno_unused_function)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-function")
	endif ()

	check_c_compiler_flag(-Wno-unused-parameter has_wno_unused_parameter)
	if (has_wno_unused_parameter)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-parameter")
	endif ()

	check_c_compiler_flag(-Wno-unreachable-code has_wno_unreachable_code)
	if (has_wno_unreachable_code)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unreachable-code")
	endif ()

	check_c_compiler_flag(-Wstrict-prototypes has_wstrict_prototypes)
	if (has_wstrict_prototypes)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wstrict-prototypes")
	endif ()

	if (sctp_werror)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
	endif ()

	if (sctp_sanitizer_address)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address,undefined,signed-integer-overflow -fno-omit-frame-pointer -fno-sanitize-recover=all -fsanitize-address-use-after-scope ")
	endif ()

	if (sctp_sanitizer_memory)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=memory -fno-omit-frame-pointer -fsanitize-memory-track-origins -fPIE")
	endif ()

	if (sctp_build_fuzzer)
		set(CMAKE_BUILD_TYPE "RelWithDebInfo")
		add_definitions(-DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=fuzzer-no-link")
	endif ()
endif ()

message(STATUS "Compiler flags (CMAKE_C_FLAGS): ${CMAKE_C_FLAGS}")


#################################################
# INCLUDE SUBDIRS
#################################################

add_subdirectory(usrsctplib)

if (sctp_build_programs)
	add_subdirectory(programs)
endif ()

if (sctp_build_fuzzer)
	add_subdirectory(fuzzer)
endif ()

=== debian/changelog ===
open5gs (2.7.6.4802.4642.202511071800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Fri, 07 Nov 2025 18:01:57 +0000

## open5gs 2.7.6.4802.4642.202511081800

=== subprojects/prometheus-client-c/Makefile ===

SHELL = /bin/bash

GITHUB_ORG = digitalocean

# Origin does not point to https://github.com/digitalocean/prometheus-client-c.git in TravisCI so we must add a new
# remote for fetching. Fetch master, diff on the filenames and look for C files. If no changes to C files are made, skip
# the build.
CHANGED_FILES = $(shell git remote add ci https://github.com/${GITHUB_ORG}/prometheus-client-c.git > /dev/null 2>&1; git fetch ci master > /dev/null 2>&1; git diff --name-only ci/master | egrep -v '.*\.md$$')

ifneq ($(shell echo "x${CHANGED_FILES}x" | sed 's/\n\t //'), xx)
default: build_and_test
else
default: build_and_test
# default: changed_files
	# @echo -e "\033[1;32mNothing to build\033[0m"
endif

build_and_test: changed_files clean build test package smoke
.PHONY: build_and_test

all: build_and_test docs
.PHONY: all

clean:
	./auto dev -e auto -a clean

build: clean
	./auto dev -e auto -a build -a -t
.PHONY: build

test: build
	./auto dev -e auto -a test
.PHONY: test

package: test
	./auto dev -e auto -a package
.PHONY: smoke

docs: smoke
	./auto dev -e auto -a docs
.PHONY: package

changed_files:
	@echo "Changed C files: ${CHANGED_FILES}"
.PHONY: changed_files

smoke: package
	./auto dev -e auto -a smoke
.PHONY: smoke

=== debian/changelog ===
open5gs (2.7.6.4802.4642.202511081800) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Sat, 08 Nov 2025 18:01:54 +0000
